futhark-0.25.32: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Internalise.Entry

Description

Generating metadata so that programs can run at all.

Synopsis

- entryPoint :: VisibleTypes -> Name -> [(EntryParam, [Param DeclType])] -> (EntryType, [[TypeBase Rank Uniqueness]]) -> (EntryPoint, OpaqueTypes)
- data VisibleTypes
- visibleTypes :: Imports -> VisibleTypes

# Documentation

entryPoint :: VisibleTypes -> Name -> [(EntryParam, [Param DeclType])] -> (EntryType, [[TypeBase Rank Uniqueness]]) -> (EntryPoint, OpaqueTypes) Source #

data VisibleTypes Source #

The types that are visible to the outside world.

visibleTypes :: Imports -> VisibleTypes Source #

Retrieve those type bindings that should be visible to the outside world. Currently that is everything at top level that does not have type parameters.